//************************************************************************************
//**  
//**  File name:     C:\proekt signal\proba\rs232.c
//**  Generated by:  Flowcode v4.1.1.55
//**  Date:          Monday, October 26, 2009 12:19:16
//**  Licence:       Professional
//**  Registered to: ????????????
//**  
//**  
//**     NOT FOR COMMERCIAL USE
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC

//Defines for microcontroller
#define P16F628A
#define MX_EE
#define MX_EE_TYPE1
#define MX_EE_SIZE 128
#define MX_UART
#define MX_UART_B
#define MX_UART_TX 2
#define MX_UART_RX 1
#define MX_PWM
#define MX_PWM_CNT 1
#define MX_PWM_TRIS1 trisb
#define MX_PWM_1 3

//Functions
#include <system.h>
#pragma CLOCK_FREQ 4000000

//Configuration data

//?????????? ???????
#include "C:\Program Files\Matrix Multimedia\Flowcode V4\FCD\internals.h"

//Macro function declarations
void FCM_execute_command();


//Variable declarations
#define FCSZ_COMMAND 8
#define FCSZ_ADRESS 2
#define FCSZ_RECEIVE 10
char FCV_COMMAND[FCSZ_COMMAND];
char FCV_ADRESS[FCSZ_ADRESS];
char FCV_ADRESS_INT;
char FCV_RECEIVE[FCSZ_RECEIVE];
char FCV_SEND;
char FCV_UNIT_ADRESS;


//Defines:

/**** Macro Substitutions ****
portc = RTS Port
trisc = RTS Data Direction
portc = CTS Port
trisc = CTS Data Direction
0 = RTS Pin
4 = CTS Pin
1 = UART Selection		(0-SW / 1-UART1 / 2-UART2)
0 = Flow Control		(0-Off / 1-On)
0 = Debug Enable		(0-Off / 1-On)
0 = Echo Enable		(0-Off / 1-On)
4 = UART TXSTA Value
12 = UART SPBRG Value
RS232_591480 = Unique ID
Unused = Bitbanged Receive Port Register
Unused = Bitbanged Receive Data Direction Register
Unused = Bitbanged Receive Pin
Unused = Bitbanged Transmit Pin
-1 = Bitbanged BAUD Rate Delay
0 = Timout	Selection	(0-Legacy / 1-MS Timeout)
0 = Data Size			(0-8 bits / 1-9 bits / 2-7 bits & Only available on BitBanged components)
0 = Parity Enable		(0-No Parity / 1-Odd Parity / 2-Even Parity)
0 = Legacy Return		(0-Legacy mode return 255 / 1-New mode return MSB err flags)
Unused = Bitbanged Transmit Port Register
Unused = Bitbanged Transmit Data Direction Register
******************************/

#define RS232_591480_RTS_PORT			portc
#define RS232_591480_RTS_TRIS			trisc
#define RS232_591480_CTS_PORT			portc
#define RS232_591480_CTS_TRIS			trisc
#define RS232_591480_RTS_PIN			0
#define RS232_591480_CTS_PIN			4
#define RS232_591480_UART				1
#define RS232_591480_TOUT  			0
#define RS232_591480_DATASIZE			0
#define RS232_591480_PARITY			0
#define RS232_591480_LEGACY_RV			0

#if (0 == 1)
  	#define RS232_591480_HARDWARE
#endif

#if (0 == 1)
  	#define RS232_591480_DEBUG
#endif

#if (0 == 1)
  	#define RS232_591480_ECHO
#endif

#if (RS232_591480_UART == 0)
	#define RS232_591480_RX_PORT		Unused
	#define RS232_591480_RX_TRIS		Unused
	#define RS232_591480_SW_RX		Unused
	#define RS232_591480_SW_TX		Unused
	#define RS232_591480_SW_BAUD		-1
	#define RS232_591480_TX_PORT		Unused
	#define RS232_591480_TX_TRIS		Unused
#else
	#define RS232_591480_TXSTA_VAL  	4
	#define RS232_591480_SPBRG_VAL  	12
	#define RS232_591480_SW_BAUD		0
#endif

#if (RS232_591480_LEGACY_RV == 0)
	#if (RS232_591480_DATASIZE == 1)
		#pragma error "RS232 Component cannot combine 9-bit data mode with legacy return value of 255 please check the Component properties"
	#endif
#endif

#define RS232_591480_STATUS_LOOP		0
#define RS232_591480_STATUS_TIMEOUT	1
#define RS232_591480_STATUS_RXBYTE	2





//RS2320: //Macro function declarations

void FCD_RS2320_SendRS232Char(short nChar);
void FCD_RS2320_SendRS232String(char* String, char MSZ_String);
short FCD_RS2320_ReceiveRS232Char(short nTimeout);
void FCD_RS2320_ReceiveRS232String(char* FCR_RETVAL, char FCR_RETVAL_SIZE, char nTimeout, char NumBytes);
void FCD_RS2320_RS232_Delay(char mode);
//Defines:

/**** Macro Substitutions ****
portb = Switch Port Register
trisb = Switch Data Direction Register
0 = Switch Pin
0 = Switch Polarity Control
0 = Switch Debounce Delay Value
******************************/




//SWITCH0: //Macro function declarations

char FCD_SWITCH0_ReadState();
void FCD_SWITCH0_WaitUntilHigh();
void FCD_SWITCH0_WaitUntilLow();



//RS2320: //Macro implementations


void FCD_RS2320_SendRS232Char(short nChar)
{
	
	#if (RS232_591480_UART == 0)

		char dMask;
		char idx;
		char count = 8;

		#ifdef RS232_591480_HARDWARE
			//wait until CTS is low
			while ((RS232_591480_CTS_PORT & (1 << RS232_591480_CTS_PIN) ) != 0);
		#endif

		#if(RS232_591480_DATASIZE == 1)
			count = 9;
		#endif
		#if(RS232_591480_DATASIZE == 2)
			count = 7;
		#endif

		clear_bit(RS232_591480_TX_PORT, RS232_591480_SW_TX);		// Send Start bit
		FCD_RS2320_RS232_Delay(0);

		for (idx = 0; idx < count; idx++)
		{
			dMask = nChar & 0x01;							// Mask off data bit

			if (dMask)
				set_bit(RS232_591480_TX_PORT, RS232_591480_SW_TX);
			else
				clear_bit(RS232_591480_TX_PORT, RS232_591480_SW_TX);

			FCD_RS2320_RS232_Delay(0);
			nChar = nChar >> 1;								// Move to next data bit
		}

		set_bit(RS232_591480_TX_PORT, RS232_591480_SW_TX);			// Send Stop bit
		FCD_RS2320_RS232_Delay(0);

	#endif

	#if (RS232_591480_UART == 1)

		#ifndef MX_UART
			#pragma error "Chip does not have UART capability"
		#endif

		set_bit(txsta, TXEN);
		while ((pir1 & (1 << TXIF)) == 0);

		#ifdef RS232_591480_HARDWARE
			//wait until CTS is low
			while ((RS232_591480_CTS_PORT & (1 << RS232_591480_CTS_PIN) ) != 0);
		#endif

		#if(RS232_591480_DATASIZE == 1)
			if (test_bit(nChar, 8))
				set_bit(txsta, TX9D);
			else
				clear_bit(txsta, TX9D);
		#endif

		txreg = nChar;

	#endif

	#if (RS232_591480_UART == 2)

		#ifndef MX_UART2
			#pragma error "Chip does not have second UART capability"
		#endif

		set_bit(txsta2, TXEN);
		while ((pir3 & (1 << TX2IF)) == 0);

		#ifdef RS232_591480_HARDWARE
			//wait until CTS is low
			while ((RS232_591480_CTS_PORT & (1 << RS232_591480_CTS_PIN) ) != 0);
		#endif

		#if(RS232_591480_DATASIZE == 1)
			if (test_bit(nChar, 8))
				set_bit(txsta2, TX9D);
			else
				clear_bit(txsta2, TX9D);
		#endif

		txreg2 = nChar;

	#endif

}

void FCD_RS2320_SendRS232String(char* String, char MSZ_String)
{
		char idx;
		for(idx = 0; idx < MSZ_String; idx++)
		{
			if (String[idx] == 0)
				break;

			else FCD_RS2320_SendRS232Char(String[idx]);
		}
}

short FCD_RS2320_ReceiveRS232Char(short nTimeout)
{
	
		char delay1 = 0;
		char delay2 = 0;
		char regcheck = 0;
		char dummy = 0;
		short retVal = 512;
		char bWaitForever = 0;
		char rxStatus = RS232_591480_STATUS_LOOP;
		char idx;
		char count = 8;

		#if (RS232_591480_LEGACY_RV == 0)
			retVal = 255;
		#endif

		#if (RS232_591480_UART == 1)
			#ifndef MX_UART
				#pragma error "Chip does not have UART capability"
			#endif
		#endif

		#if (RS232_591480_UART == 2)
			#ifndef MX_UART2
				#pragma error "Chip does not have second UART capability"
			#endif
		#endif

		#ifdef RS232_591480_HARDWARE
			//ready to accept data
			clear_bit(RS232_591480_RTS_PORT, RS232_591480_RTS_PIN);
		#endif

		if (nTimeout == 255)
			bWaitForever = 1;

		#if (RS232_591480_UART == 1)
			set_bit(rcsta, CREN);
		#endif

		#if (RS232_591480_UART == 2)
			set_bit(rcsta2, CREN);
		#endif

		while (rxStatus == RS232_591480_STATUS_LOOP)
		{
			if (bWaitForever == 0)
			{
				//don't wait forever, so do timeout thing...
				if (nTimeout == 0)
				{
					rxStatus = RS232_591480_STATUS_TIMEOUT;
				}
				else
				{
					if (RS232_591480_TOUT)
					{
						delay_10us(1);
						delay1 = delay1 + 1;
						if(delay1 == 100)
						{
							nTimeout = nTimeout - 1;
							delay1 = 0;
						}
					}
					else
					{
						//decrement timeout
						delay1 = delay1 - 1;
						if (delay1 == 0)
						{
							nTimeout = nTimeout - 1;
						}
					}
				}
			}

			#if (RS232_591480_UART == 0)
				regcheck = test_bit(RS232_591480_RX_PORT, RS232_591480_SW_RX);	//Test for start bit
				if (regcheck == 0)
					rxStatus = RS232_591480_STATUS_RXBYTE;
			#endif

			#if (RS232_591480_UART == 1)
				regcheck = (pir1 & (1 << RCIF));
				if (regcheck != 0)
					rxStatus = RS232_591480_STATUS_RXBYTE;
			#endif

			#if (RS232_591480_UART == 2)
				regcheck = (pir3 & (1 << RC2IF));
				if (regcheck != 0)
					rxStatus = RS232_591480_STATUS_RXBYTE;
			#endif
		}

		if (rxStatus == RS232_591480_STATUS_RXBYTE)
		{
			#if (RS232_591480_UART > 0)

				#if (RS232_591480_UART == 1)
					regcheck = (rcsta & (1 << FERR));
				#endif

				#if (RS232_591480_UART == 2)
					regcheck = (rcsta2 & (1 << FERR));
				#endif

				if (regcheck != 0)
				{
					#if (RS232_591480_UART == 1)
						dummy = rcreg;      //need to read the rcreg to clear FERR
					#endif

					#if (RS232_591480_UART == 2)
						dummy = rcreg2;      //need to read the rcreg to clear FERR
					#endif

					#ifdef RS232_591480_DEBUG
						FCD_RS2320_SendRS232Char('<');
						FCD_RS2320_SendRS232Char('F');
						FCD_RS2320_SendRS232Char('E');
						FCD_RS2320_SendRS232Char('R');
						FCD_RS2320_SendRS232Char('R');
						FCD_RS2320_SendRS232Char('>');
					#endif

					#if (RS232_591480_LEGACY_RV == 1)
						retVal = 0x400;					//Framing Error Flag
					#endif
				}
				else
				{
					#if (RS232_591480_UART == 1)
						regcheck = (rcsta & (1 << OERR));
					#endif

					#if (RS232_591480_UART == 2)
						regcheck = (rcsta2 & (1 << OERR));
					#endif

					if (regcheck != 0)
					{
						//need to read the rcreg to clear error
						#if (RS232_591480_UART == 1)
							clear_bit(rcsta, CREN);
							set_bit(rcsta, CREN);
						#endif

						#if (RS232_591480_UART == 2)
							clear_bit(rcsta2, CREN);
							set_bit(rcsta2, CREN);
						#endif

						#ifdef RS232_591480_DEBUG
							FCD_RS2320_SendRS232Char('<');
							FCD_RS2320_SendRS232Char('O');
							FCD_RS2320_SendRS232Char('E');
							FCD_RS2320_SendRS232Char('R');
							FCD_RS2320_SendRS232Char('R');
							FCD_RS2320_SendRS232Char('>');
						#endif

						#if (RS232_591480_LEGACY_RV == 1)
							retVal = 0x800;					//Overrun Error Flag
						#endif

					}
					else
					{
						#if (RS232_591480_UART == 1)
							retVal = rcreg; 			//no error, so rx byte is valid

							#if(RS232_591480_DATASIZE == 1)
								if(test_bit(rcsta, RX9D));
									retVal = retVal | 0x100;
							#endif

						#endif

						#if (RS232_591480_UART == 2)
							retVal = rcreg2; 			//no error, so rx byte is valid

							#if(RS232_591480_DATASIZE == 1)
								if(test_bit(rcsta2, RX9D));
									retVal = retVal | 0x100;
							#endif

						#endif

						#ifdef RS232_591480_ECHO
							FCD_RS2320_SendRS232Char(retVal);
						#endif
					}
				}
			#else
				#if(RS232_591480_DATASIZE == 1)
					count = 9;
				#endif

				FCD_RS2320_RS232_Delay(1);
				for (idx = 0; idx < count; idx++)
				{
					retVal = retVal >> 1;

					if(count == 9)
					{
						if (test_bit(RS232_591480_RX_PORT, RS232_591480_SW_RX))
							retVal = retVal | 0x100;
					}
					else
					{
						if (test_bit(RS232_591480_RX_PORT, RS232_591480_SW_RX))
							retVal = retVal | 0x80;
					}
					FCD_RS2320_RS232_Delay(1);
				}

				#ifdef RS232_591480_ECHO
					FCD_RS2320_SendRS232Char(retVal);
				#endif

			#endif
		}
		#ifdef RS232_591480_HARDWARE
			//not ready to accept data
			set_bit(FC_RS232_RTS_PORT, FC_RS232_RTS_PIN);
		#endif

		return (retVal);
}

void FCD_RS2320_ReceiveRS232String(char* FCR_RETVAL, char FCR_RETVAL_SIZE, char nTimeout, char NumBytes)
{
		char idx;
		short in;

		#if ( RS232_591480_LEGACY_RV == 0 )
			#define RS232_TO 	255
		#else
			#define RS232_TO 	256
		#endif

		if (NumBytes > FCR_RETVAL_SIZE)
			NumBytes = FCR_RETVAL_SIZE;

		for (idx = 0; idx < NumBytes; idx++)
		{
			in = FCD_RS2320_ReceiveRS232Char(nTimeout);
			if(in < RS232_TO)
				FCR_RETVAL[idx] = in & 0xFF;
			else
				break;
		}

		if (idx < FCR_RETVAL_SIZE)
			FCR_RETVAL[idx] = 0;

		#undef RS232_TO
}

void FCD_RS2320_RS232_Delay(char mode)
{
		unsigned int iterations;
		unsigned int delay = RS232_591480_SW_BAUD;

		if (mode)
			delay = delay + 1;

		for (iterations = 0; iterations < delay; iterations++);
}



//SWITCH0: //Macro implementations


char FCD_SWITCH0_ReadState()
{
	
		char switchval;

		set_bit ( trisb, 0 );					//Convert pin to input
		nop();								//Allow input voltage to settle

		if (test_bit( portb, 0 ))				//Read state on input
			switchval = 1;
		else
			switchval = 0;

		if ( 0 == 1 )						//Active low polarity
		{
			if (switchval)					//Invert logic
				switchval = 0;
			else
				switchval = 1;
		}
		return (switchval);			//Return state of switch as least significant bit

}

void FCD_SWITCH0_WaitUntilHigh()
{
	
		set_bit ( trisb, 0 );						//Convert pin to input
		nop();									//Allow input voltage to settle

		if ( 0  == 0 )							//Active high polarity
		{
			while (test_bit( portb, 0 ) == 0);	//Wait for pin to go high
		}
		else									//Active low polarity
		{
			while (test_bit( portb, 0 ));			//Wait for pin to go low
		}
		if ( 0 )								//Timeout specified?
			Wdt_Delay_Ms(0);

}

void FCD_SWITCH0_WaitUntilLow()
{
	
		set_bit ( trisb, 0 );						//Convert pin to input
		nop();									//Allow input voltage to settle

		if ( 0 == 0 )							//Active high polarity
		{
			while (test_bit( portb, 0 ));			//Wait for pin to go low
		}
		else									//Active low polarity
		{
			while (test_bit( portb, 0 ) == 0);	//Wait for pin to go high
		}
		if ( 0 )								//Timeout specified?
			Wdt_Delay_Ms(0);

}

//Macro implementations

void FCM_execute_command()
{
	
	//Output
	//?????: 1 -> B3
	trisb = trisb & 0xf7;
	if (1)
		portb = (portb & 0xf7) | 0x08;
	else
		portb = portb & 0xf7;


	//Delay
	//????????: 2 ?
	delay_s(2);


	//Output
	//?????: 0 -> B3
	trisb = trisb & 0xf7;
	if (0)
		portb = (portb & 0xf7) | 0x08;
	else
		portb = portb & 0xf7;


}

void main()
{
	
	//Initialisation
	cmcon = 0x07;

	
	#if (RS232_591480_UART == 0)
		set_bit(RS232_591480_RX_TRIS, RS232_591480_SW_RX);		// Receive pin is a input
		clear_bit(RS232_591480_TX_TRIS, RS232_591480_SW_TX);	// Transmit pin is a output
		set_bit(RS232_591480_TX_PORT, RS232_591480_SW_TX);		// Transmit pin is default high
	#endif

	#if (RS232_591480_UART == 1)
		txsta = RS232_591480_TXSTA_VAL;   					// 8-bit, async, low speed, off
		spbrg = RS232_591480_SPBRG_VAL;   					// set the baud rate
		rcsta = 0;                    				// 8-bit, disabled

		if(RS232_591480_DATASIZE == 1)
		{
			set_bit(txsta, TX9);   						// 9-bit TX
			set_bit(rcsta, RX9);                    	// 9-bit RX
		}

		set_bit(rcsta, SPEN);         					// turn on serial interface
	#endif

	#if (RS232_591480_UART == 2)

		txsta2 = RS232_591480_TXSTA_VAL;   					// 8-bit, async, low speed, off
		spbrg2 = RS232_591480_SPBRG_VAL;   					// set the baud rate
		rcsta2 = 0;                    					// 8-bit, disabled

		if(RS232_591480_DATASIZE == 1)
		{
			set_bit(txsta2, TX9);   					// 9-bit TX
			set_bit(rcsta2, RX9);                    	// 9-bit RX
		}

		set_bit(rcsta2, SPEN);         					// turn on serial interface
	#endif

	#ifdef RS232_591480_HARDWARE
		set_bit(FC_RS232_CTS_TRIS, FC_RS232_CTS_PIN);	//CTS is an input
		clear_bit(FC_RS232_RTS_TRIS, FC_RS232_RTS_PIN);	//RTS is an output
		set_bit(FC_RS232_RTS_PORT, FC_RS232_RTS_PIN); 	//not ready to accept data
	#endif


	//Interrupt initialisation code
	option_reg = 0xC0;


	//Calculation
	//??????????:
	//  unit_adress = 1
	FCV_UNIT_ADRESS = 1;
	

	//Output
	//?????: 0 -> B4
	trisb = trisb & 0xef;
	if (0)
		portb = (portb & 0xef) | 0x10;
	else
		portb = portb & 0xef;


	//Loop
	//????: While 1
	while (1)
	{
		//Input
		//????: B0 -> send
		trisb = trisb | 0x01;
		FCV_SEND = ((portb & 0x01) == 0x01);


		//Call Component Macro
		//?????? ??????????: SWITCH(0)::WaitUntilLow
		FCD_SWITCH0_WaitUntilLow();


		//Decision
		//???????: send = 1?
		if (FCV_SEND == 1)
		{
			//Call Component Macro
			//?????? ??????????: RS232(0)::SendRS232Char("atd>"sm"1;")
			FCD_RS2320_SendRS232Char('a');
			FCD_RS2320_SendRS232Char('t');
			FCD_RS2320_SendRS232Char('d');
			FCD_RS2320_SendRS232Char('>');
			FCD_RS2320_SendRS232Char(34);
			FCD_RS2320_SendRS232Char('s');
			FCD_RS2320_SendRS232Char('m');
			FCD_RS2320_SendRS232Char(34);
			FCD_RS2320_SendRS232Char('1');
			FCD_RS2320_SendRS232Char(';');


		} else {
			//Call Component Macro
			//?????? ??????????: receive=RS232(0)::ReceiveRS232String(50, 10)
			FCD_RS2320_ReceiveRS232String(FCV_RECEIVE, 10, 50, 10);


			//String Manipulation
			//????????? ?????:
			//  adress = Left$(receive, 2)
			//  command = Mid$(receive, 2, 8)
			//  adress_int = StringToInt$(adress)
			FCI_LEFTSTRING(FCV_RECEIVE,FCSZ_RECEIVE,FCV_ADRESS,FCSZ_ADRESS,2);
			FCI_MIDSTRING(FCV_RECEIVE,FCSZ_RECEIVE,FCV_COMMAND,FCSZ_COMMAND,2,8);
			FCV_ADRESS_INT = FCI_STRING_TO_INT(FCV_ADRESS,FCSZ_ADRESS);
			

		}


		//Decision
		//???????: adress_int = unit_adress?
		if (FCV_ADRESS_INT == FCV_UNIT_ADRESS)
		{
			//Call Macro
			//?????: execute_command
			FCM_execute_command();


		}


	}


	mainendloop: goto mainendloop;
}

void interrupt(void)
{
}



